<?php

declare(strict_types=1);

namespace Drupal\simple_push;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\simple_push\Attribute\SimplePushBackend;

/**
 * SimplePushBackend plugin manager.
 */
final class SimplePushBackendPluginManager extends DefaultPluginManager {

  /**
   * Constructs the object.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct('Plugin/SimplePushBackend', $namespaces, $module_handler, SimplePushBackendInterface::class, SimplePushBackend::class);
    $this->alterInfo('simple_push_backend_info');
    $this->setCacheBackend($cache_backend, 'simple_push_backend_plugins');
  }

}
